Package net.sf.saxon.expr.instruct

## Class CopyOf

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.CopyOf

- All Implemented Interfaces:
    `ExportAgent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`

      public class CopyOf
      extends Instruction
      implements ValidatingInstruction

  An xsl:copy-of element in the stylesheet.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CopyOf​(Expression select, boolean copyNamespaces, int validation, SchemaType schemaType, boolean rejectDuplicateAttributes)` | Create an xsl:copy-of instruction (also used in XQuery for implicit copying)

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `static java.lang.String` | `computeNewBaseUri​(NodeInfo source, java.lang.String staticBaseURI)` |
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `int` | `getCardinality()` | Determine the static cardinality of the expression.
    `int` | `getDependencies()` | Determine which aspects of the context the expression depends on.
    `int` | `getImplementationMethod()` | An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `int` | `getInstructionNameCode()` | Get the name of this instruction, for diagnostics and tracing
    `ItemType` | `getItemType()` | Get the item type of the items returned by evaluating this instruction
    `SchemaType` | `getSchemaType()` | Get the schema type to be used for validation
    `Expression` | `getSelect()` |
    `UType` | `getStaticUType​(UType contextItemType)` | Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
    `java.lang.String` | `getStreamerName()` | Get the (partial) name of a class that supports streaming of this kind of expression
    `int` | `getValidationAction()` | Get the validation mode
    `boolean` | `isCopyAccumulators()` | Ask whether accumulator values should be copied from the source document
    `boolean` | `isCopyForUpdate()` | Ask whether this instruction is creating a copy for the purpose of updating (XQuery transform expression)
    `boolean` | `isCopyNamespaces()` | Ask whether namespaces are to be copied or not
    `boolean` | `isDocumentOrElementRequired()` | Test whether this expression requires a document or element node
    `boolean` | `isValidating()` | Test if the instruction is doing validation
    `SequenceIterator` | `iterate​(XPathContext context)` | Return an Iterator to iterate over the values of a sequence.
    `boolean` | `mayCreateNewNodes()` | Determine whether this instruction creates new nodes.
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `TailCall` | `processLeavingTail​(Outputter out, XPathContext context)` | Process this xsl:copy-of instruction
    `void` | `setCopyAccumulators​(boolean copy)` | Say whether accumulator values should be copied from the source document
    `void` | `setCopyForUpdate​(boolean forUpdate)` | Set whether this instruction is creating a copy for the purpose of updating (XQuery transform expression)
    `void` | `setCopyLineNumbers​(boolean copy)` | Set whether line numbers are to be copied from the source to the result.
    `void` | `setRequireDocumentOrElement​(boolean requireDocumentOrElement)` | For XQuery, the operand (select) must be a single element or document node.
    `void` | `setSchemaAware​(boolean schemaAware)` | Set the "is schema aware" property
    `void` | `setSelect​(Expression select)` | Set the select expression
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform type checking of an expression and its subexpressions.
    `static SimpleType` | `validateAttribute​(NodeInfo source, SimpleType schemaType, int validation, XPathContext context)` | Validate an attribute node and return the type annotation to be used

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `alwaysCreatesNewNodes, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, evaluateAsString, evaluateItem, getExpressionName, getNetCost, getSourceLocator, isInstruction, isXSLT, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getConfiguration, getCost, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### CopyOf

          public CopyOf​(Expression select,
                        boolean copyNamespaces,
                        int validation,
                        SchemaType schemaType,
                        boolean rejectDuplicateAttributes)

      Create an xsl:copy-of instruction (also used in XQuery for implicit copying)
      Parameters:
        `select` - expression that selects the nodes to be copied
        `copyNamespaces` - true if namespaces are to be copied
        `validation` - validation mode for the result tree
        `schemaType` - schema type for validating the result tree
        `rejectDuplicateAttributes` - true if duplicate attributes are to be rejected (XQuery). False if duplicates are handled by discarding all but the first (XSLT).

  - ### Method Detail

    - #### getSelect

          public Expression getSelect()

    - #### setSelect

          public void setSelect​(Expression select)

      Set the select expression
      Parameters:
        `select` - the new select expression

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Specified by:
        `operands` in class `Instruction`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### getValidationAction

          public int getValidationAction()

      Get the validation mode
      Specified by:
        `getValidationAction` in interface `ValidatingInstruction`
      Returns:
        the validation mode

    - #### isValidating

          public boolean isValidating()

      Test if the instruction is doing validation
      Returns:
        true if it is

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the schema type to be used for validation
      Specified by:
        `getSchemaType` in interface `ValidatingInstruction`
      Returns:
        the schema type, or null if not validating against a type

    - #### setSchemaAware

          public void setSchemaAware​(boolean schemaAware)

      Set the "is schema aware" property
      Parameters:
        `schemaAware` - true if schema awareness is enabled

    - #### setCopyLineNumbers

          public void setCopyLineNumbers​(boolean copy)

      Set whether line numbers are to be copied from the source to the result. Default is false.
      Parameters:
        `copy` - true if line numbers are to be copied

    - #### mayCreateNewNodes

          public final boolean mayCreateNewNodes()

      Determine whether this instruction creates new nodes. The result depends on the type of the select expression.
      Overrides:
        `mayCreateNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes under some input conditions (or if it can't be proved that it doesn't)

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction, for diagnostics and tracing
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### setRequireDocumentOrElement

          public void setRequireDocumentOrElement​(boolean requireDocumentOrElement)

      For XQuery, the operand (select) must be a single element or document node.
      Parameters:
        `requireDocumentOrElement` - true if the argument must be a single element or document node

    - #### isDocumentOrElementRequired

          public boolean isDocumentOrElementRequired()

      Test whether this expression requires a document or element node
      Returns:
        true if this expression requires the value of the argument to be a document or element node, false if there is no such requirement

    - #### setCopyForUpdate

          public void setCopyForUpdate​(boolean forUpdate)

      Set whether this instruction is creating a copy for the purpose of updating (XQuery transform expression)
      Parameters:
        `forUpdate` - true if this copy is being created to support an update

    - #### isCopyForUpdate

          public boolean isCopyForUpdate()

      Ask whether this instruction is creating a copy for the purpose of updating (XQuery transform expression)
      Returns:
        true if this copy is being created to support an update

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided. This implementation provides both iterate() and process() methods natively.
      Overrides:
        `getImplementationMethod` in class `Instruction`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### isCopyNamespaces

          public boolean isCopyNamespaces()

      Ask whether namespaces are to be copied or not
      Returns:
        true if namespaces are to be copied (the default)

    - #### setCopyAccumulators

          public void setCopyAccumulators​(boolean copy)

      Say whether accumulator values should be copied from the source document
      Parameters:
        `copy` - true if values should be copied

    - #### isCopyAccumulators

          public boolean isCopyAccumulators()

      Ask whether accumulator values should be copied from the source document
      Returns:
        true if values should be copied

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - information about variables whose bindings need to be replaced
      Returns:
        the copy of the original expression

    - #### getItemType

          public ItemType getItemType()

      Description copied from class: `Instruction`
      Get the item type of the items returned by evaluating this instruction
      Overrides:
        `getItemType` in class `Instruction`
      Returns:
        the static item type of the instruction

    - #### getStaticUType

          public UType getStaticUType​(UType contextItemType)

      Description copied from class: `Expression`
      Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
      Overrides:
        `getStaticUType` in class `Expression`
      Parameters:
        `contextItemType` - the static type of the context item
      Returns:
        the static item type of the expression according to the XSLT 3.0 defined rules

    - #### getCardinality

          public int getCardinality()

      Description copied from class: `Expression`
      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### getDependencies

          public int getDependencies()

      Description copied from class: `Expression`
      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.
      Overrides:
        `getDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the dependencies of the expression

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Get the (partial) name of a class that supports streaming of this kind of expression
      Overrides:
        `getStreamerName` in class `Expression`
      Returns:
        the partial name of a class that can be instantiated to provide streaming support in Saxon-EE, or null if there is no such class

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNodeSet representing the points in the source document that are both reachable by this expression, and that represent possible results of this expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### processLeavingTail

          public TailCall processLeavingTail​(Outputter out,
                                             XPathContext context)
                                      throws XPathException

      Process this xsl:copy-of instruction
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `out` -
        `context` - the dynamic context for the transformation
      Returns:
        null - this implementation of the method never returns a TailCall
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### computeNewBaseUri

          public static java.lang.String computeNewBaseUri​(NodeInfo source,
                                                           java.lang.String staticBaseURI)

    - #### validateAttribute

          public static SimpleType validateAttribute​(NodeInfo source,
                                                     SimpleType schemaType,
                                                     int validation,
                                                     XPathContext context)
                                              throws XPathException

      Validate an attribute node and return the type annotation to be used
      Parameters:
        `source` - the node to be copied
        `schemaType` - the simple type against which the value is to be validated, if any
        `validation` - one of preserve, strip, strict, lax
        `context` - the dynamic context
      Returns:
        the type annotation to be used for the attribute
      Throws:
        `XPathException` - if the attribute is not valid

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Description copied from class: `Instruction`
      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Instruction`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression